//freeslot defs
freeslot(
"SKINCOLOR_NORMALAJ",
"SKINCOLOR_FIREAJ",
"SKINCOLOR_HITMANAJ"
)

skincolors[SKINCOLOR_NORMALAJ] = {
    name = "NormalAj",
    ramp = {0,80,81,80,82,73,73,52,55,56,150,151,153,155,157,159
},
    invcolor = SKINCOLOR_YELLOW,
    invshade = 9,
    chatcolor = V_YELLOWMAP,
    accessible = true
}

skincolors[SKINCOLOR_FIREAJ] = {
    name = "FireAj",
    ramp = {0,80,81,80,82,73,73,52,55,56,32,33,34,35,36,37
},
    invcolor = SKINCOLOR_YELLOW,
    invshade = 9,
    chatcolor = V_YELLOWMAP,
    accessible = true
}

skincolors[SKINCOLOR_HITMANAJ] = {
    name = "SuitAj",
    ramp = {21,22,23,24,25,26,27,28,29,31,151,154,155,157,158,253
},
    invcolor = SKINCOLOR_YELLOW,
    invshade = 9,
    chatcolor = V_YELLOWMAP,
    accessible = true
}

freeslot(
"SPR2_GPND",
"SPR2_GPFL",
"SPR2_SLDE", 
"SPR2_WALL", 
"SPR2_DVLN", 
"SPR2_TRK1", 
"SPR2_TRK2", 
"SPR2_TRK3",
"SPR2_DUCK",
"SPR2_DWLK",
"SPR2_FLOS",
"sfx_dive",
"sfx_pnch",
"sfx_dedd")

//DOUBLE JUMP
local skin = "aj"
local ajheight = 10
local sound = sfx_putput
local circlespawneffect = true
local objectspawned = MT_SPINDUST
local objectspeed = 20
local changestate = true
local thestate = S_PLAY_SPRING

addHook("PlayerSpawn", function(player)
    if player.mo and player.mo.skin == skin
		player.mo.charability = CA_NONE 
	end
end)

addHook("AbilitySpecial", function(player)
    if player.mo and player.mo.skin == skin
	and not (player.pflags & PF_THOKKED)
		player.pflags = $1|PF_THOKKED
		P_SetObjectMomZ(player.mo,ajheight*FRACUNIT)
		S_StartSound(player.mo, sound)
		player.mo.state = S_PLAY_SPRING
		if circlespawneffect == true
			for i = 1, 16 
				local object = P_SpawnMobjFromMobj(player.mo, 0,0,0,objectspawned)
				object.target = player.mo
				object.fuse = TICRATE
				object.scale = player.mo.scale
				object.destscale = player.mo.scale/8
				P_InstaThrust(object, i*ANGLE_22h, objectspeed*FRACUNIT)
				object.momz = 0
			end
		end
		if changestate == true
			player.mo.state = thestate
		end
		
    end
end)

//dive
addHook("PlayerThink",function(player)
  if player.mo.skin ~= "aj"
  or player.mo.state == S_PLAY_STUN
  or player.mo.state == S_PLAY_STND
  or player.mo.state == S_PLAY_WAIT
  or player.mo.state == S_PLAY_PAIN
  or player.mo.state == S_PLAY_DEAD
  or player.mo.state == S_PLAY_DRWN
  or player.mo.state == S_PLAY_DEADLAND
  or player.mo.state == S_PLAY_DEADLANDALT
  or player.mo.state == S_PLAY_DEADLANDDEFAULT
  or player.pflags & PF_FINISHED
  or (player.powers[pw_shield] & SH_FIREFLOWER)
  then return end
  
  if (player.cmd.buttons & BT_CUSTOM1) and not(player.pflags & PF_THOKKED)
    P_Thrust(player.mo,player.mo.angle, 13*FU)
    P_SetObjectMomZ(player.mo,7*FU)
	S_StartSound(mobj, sfx_dive)
	
    player.mo.state = S_PLAY_GLIDE
	player.pflags = $|PF_THOKKED
	player.powers[pw_strong] = STR_ATTACK|STR_ANIM
	
  end
end)

//dive but if you double jump
addHook("PlayerThink",function(player)
  if player.mo.skin ~= "aj"
  or player.mo.state == S_PLAY_STUN
  or player.mo.state == S_PLAY_STND
  or player.mo.state == S_PLAY_WAIT
  or player.mo.state == S_PLAY_PAIN
  or player.mo.state == S_PLAY_DEAD
  or player.mo.state == S_PLAY_DRWN
  or player.mo.state == S_PLAY_DEADLAND
  or player.mo.state == S_PLAY_DEADLANDALT
  or player.mo.state == S_PLAY_DEADLANDDEFAULT
  or player.pflags & PF_FINISHED
  or (player.powers[pw_shield] & SH_FIREFLOWER)
  then return end
  
  if (player.cmd.buttons & BT_CUSTOM1) and player.mo.state == S_PLAY_SPRING or (player.cmd.buttons & BT_CUSTOM1) and player.mo.state == S_PLAY_FALL
    P_Thrust(player.mo,player.mo.angle, 13*FU)
    P_SetObjectMomZ(player.mo,7*FU)
	S_StartSound(mobj, sfx_dive)
	
    player.mo.state = S_PLAY_GLIDE
	player.pflags = $|PF_THOKKED
	player.powers[pw_strong] = STR_ATTACK|STR_ANIM
	
  end
end)

//the money that was made couldn't be scared money, i had no one to break the bread for me


//crouch
addHook("PlayerThink", function(p) --main hook
	local pmo = p.mo //local variable for simplicity
	
	if not ((pmo and pmo.valid) or (pmo.skin == "aj") or (pmo.health) or (p.exiting))
	//our player check
		return
	end
	
	if pmo.usetics != nil and (p.cmd.buttons & BT_CUSTOM2) //lets set up the counter for how many tics our button is pressed
		pmo.usetics = $ + 1 //if held, the counter goes up by 1.
	else
		pmo.usetics = 0 //other wise set to 0.
	end
	
	local crouchheight = 30*FRACUNIT -- set the height for the crouch, though you can also use p.spinheight
	
	if P_IsObjectOnGround(pmo) and not (p.pflags&PF_SPINNING) -- is the player grounded?
		if (pmo.usetics ~= 0)
		 --and (p.speed <= p.runspeed/4) //the player is pressing the specified button (our case, SPIN) and, if added back in (remove the /* */), slower than a specified speed.
			pmo.state = S_PLAY_GLIDE_LANDING -- set our animation, add sprites with the sprite subset of LAND with your character's sprites for a custom sprite.
			p.pflags = $|PF_STASIS --make sure the player can't move
			p.height = crouchheight --change the height
		else --we can use the delay from the alredy made code for the glide landing animation to a different one to our advantage!
			if (pmo.state == S_PLAY_GLIDE_LANDING) 
				p.height = 48*FRACUNIT --set our height back to normal
				if  p.pflags&PF_STASIS
					p.pflags = $ & ~PF_STASIS --allow movement
				end
			end
		end
		
		if ((pmo.state == S_PLAY_GLIDE_LANDING) and (pmo.usetics)) and (p.speed >= p.runspeed/3) --dust effects
			P_SpawnSkidDust(p, 15*FRACUNIT, sfx_s3k7e) --dust bs
		end
	end
end)